/* DO NOT EDIT! 
** This file has been automatically generated from "mpoll.c" */
#ifdef __cplusplus
#  define EXTERN extern "C"
#else
#  define EXTERN extern
#endif
EXTERN int Et_Eval(const char *,int,const char*,...);
EXTERN int Et_EvalInt(const char *,int,const char*,...);
EXTERN char *Et_EvalString(const char *,int,const char*,...);
EXTERN double Et_EvalDouble(const char *,int,const char*,...);
EXTERN void Et_EvalInclude(const char *,char *);
EXTERN void Et_Init(int *, char **);
EXTERN void Et_MainLoop(void);
EXTERN void Et_ReadStdin(void);
EXTERN struct Tcl_Interp *Et_Interp;
EXTERN struct Tk_Window_ *Et_MainWindow;
EXTERN struct _XDisplay *Et_Display;
#define ET_OK 0
#define ET_ERROR 1
#undef EXTERN
#define UNIX 1
#line 1 "mpoll.c"
/*  @(#)mpoll.c	1.5  97/12/23  */

/*
 * Copyright (c) Communications Research Centre, Government of Canada 1997. 
 * All rights reserved.
 * 
 * License is granted to copy and use this software, for research and
 * evaluation purposes, provided that the Communications Research Centre
 * is acknowledged in all documentation pertaining to any such copy or
 * use. The Communications Research Centre grants no other licenses
 * expressed or implied. Title, ownership rights, and intellectual
 * property rights in the software shall remain with the Communications
 * Research Centre.  The Centre's name and the Government of Canada
 * should not be used in any advertising without written permission.
 * 
 * THE COMMUNICATIONS RESEARCH CENTRE MAKES NO REPRESENTATIONS CONCERNING
 * EITHER THE MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF
 * THIS SOFTWARE FOR ANY PARTICULAR PURPOSE.  The software is provided
 * "as is" without express or implied warranty of any kind.
 * 
 * These notices must be retained in any copies of any part of this
 * software.
 */


#include "mpoll.h"
#ifndef WIN32
#include <sys/utsname.h>
#endif

#ifdef WIN32
extern int WinPutsCmd(ClientData, Tcl_Interp*, int, char **);
#endif

/* the main data structures for topics, responses, and
   also my local responses */
    
struct topic topiclist[MAX_TOPICS+1]; 
struct response responselist[MAX_TOPICS+1*MAX_RESPONSES*1000]; 
struct response myresponse[MAX_TOPICS+1*MAX_RESPONSES+1];

/* counters for the topics and responses */
int numtopics = 0, topicnum = 0;
int numresponses = 0, responsenum = 0;
int nummyresponses = 0, myresponsenum = 0;

/* handle topics that are deleted */
int numdeleted;
struct topic deltopics[MAX_TOPICS+1];

/* counter for number of members */
int nummembers;

/* and structure for member information */
struct member memberlist[MAX_MEMBERS+1];

 
/* SCCS version information */
char vernum[] = "1.5";

/* scratch space */
char messbuf[1024];

/* info about local host and user */
char hostname[TMPSTRLEN];
char hostip[TMPSTRLEN];
/* local address number in network byte order */
unsigned long hostaddr; 
char username[TMPSTRLEN];
char systeminfo[TMPSTRLEN];

/* command line variables */
char *address = NULL;
#ifdef WIN32
u_short port;
int ttl;
#else
int port;
char ttl;
#endif

int logging = 0; /* flag for logging debugging information */

/* flag for simulating data for demos */
int simulate = 0;

/* variables to share with TCL */
char *theme;
char *version;
char *current_summary;
char *current_question;
char *current_author;
char *current_option;
char *current_time;
int current_decay;
char *default_font;
char *small_font;

/* -------------------------------------------------------------- */
#ifdef WIN32
void Et_Main(int argc, char **argv)
#else
void main(int argc, char **argv)
#endif
   {
   int arg, use_defaults;
   char *address_end;
   
   /* setup the random number generator */
   srand( (unsigned)time( NULL ) );

#ifdef WIN32
   init_win_sockets();  /* start the WIN32 socket library */
#endif
   
   learn_local_info(); /* hostname and user info */

   /* startup TCL/Tk processing */
#ifndef WIN32   
   Et_Init(&argc,argv);
#endif
   
   /* learn the new TCL commands in this file, and other C files */
   {void Et_Init_mpoll_c(void); Et_Init_mpoll_c();};
   {void Et_Init_results_c(void); Et_Init_results_c();};
   {void Et_Init_save_c(void); Et_Init_save_c();};
   {void Et_Init_submit_c(void); Et_Init_submit_c();};
   {void Et_Init_view_c(void); Et_Init_view_c();};
   
   #ifdef WIN32
   /* build a new puts command for WIN32 since we don't have a stdout */
   Tcl_CreateCommand(Et_Interp, "puts", WinPutsCmd, 0, 0);
   #endif
   
   /* load in the Tcl help procs */
   { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc helpme topic {\n"
"\n"
"if {[winfo exists .help] != 0} {\n"
"destroy .help\n"
"}\n"
"\n"
"toplevel .help\n"
"wm title .help \"MPoll help\"\n"
"\n"
"frame .help.top\n"
"pack .help.top -side \"top\" -fill both -expand yes\n"
"\n"
"text .help.top.textwin \\\n"
"-wrap \"none\" \\\n"
"-width 60 \\\n"
"-height 16 \\\n"
"-yscrollcommand \".help.top.scroll set\" \\\n"
"-font fixed\n"
"\n"
"scrollbar .help.top.scroll \\\n"
"-orient vertical \\\n"
"-command \".help.top.textwin yview\"\n"
"\n"
"pack .help.top.scroll -side right -fill y\n"
"pack .help.top.textwin -expand yes -fill both\n"
"\n"
"if {$topic == \"about\"} {\n"
"help_about\n"
"} elseif {$topic == \"topics\"} {\n"
"help_topics\n"
"} elseif {$topic == \"quest\"} {\n"
"help_quest\n"
"} elseif {$topic == \"create\"} {\n"
"help_create\n"
"} elseif {$topic == \"results\"} {\n"
"help_results\n"
"} elseif {$topic == \"string-results\"} {\n"
"help_string_results\n"
"} elseif {$topic == \"monitor\"} {\n"
"help_monitor\n"
"} elseif {$topic == \"log\"} {\n"
"help_log\n"
"} elseif {$topic == \"members\"} {\n"
"help_members\n"
"} else {\n"
".help.top.textwin insert 0.0 \\\n"
"{ERROR: unknown topic for help request on: $topic.}   \n"
"}\n"
"\n"
".help.top.textwin configure -state disabled\n"
"\n"
"\n"
"\n"
"frame .help.bottomframe\n"
"pack .help.bottomframe -side \"bottom\"  -fill  \"x\" -pady 3\n"
"\n"
"button .help.bottomframe.dismiss \\\n"
"-text \"Dismiss\" \\\n"
"-command {destroy .help} -font fixed\n"
"pack .help.bottomframe.dismiss -side  \"right\"\n"
"}\n"
"\n"
"\n"
"proc help_about {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{\"MPoll\" is a real-time opinion polling and rating collection tool\n"
"that uses multicasting to distribute questions and responses to all\n"
"the participants. \"MPoll\" was developed by Andrew Patrick at the\n"
"Communications Research Centre (CRC) in Ottawa, Canada, as part of\n"
"the MERCI project on Collaborative Work Tools.\n"
"\n"
"For more information about MPoll, see\n"
"http://debra.dgbt.doc.ca/mbone/mpoll/\n"
"or contact\n"
"Andrew.Patrick@crc.doc.ca\n"
"\n"
"\"MPoll\" is Copyright (c) Communications Research Centre, Government\n"
"of Canada, 1997.  All Rights Reserved. Contact the author for\n"
"distribution information.\n"
"}\n"
"}\n"
"\n"
"\n"
"proc help_topics {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{This is the main topic window for MPoll.  A list of question topics\n"
"will appear on the left hand side when users create questions.   To\n"
"select a topic, single-click Button 1 (left) on the topic. The\n"
"buttons on the right side then allow you to:\n"
"\n"
"- view the question and make your response\n"
"- view the results\n"
"- create a new question\n"
"- delete a question that you created\n"
"\n"
"Further help is available when each function is used.\n"
"\n"
"In addition, MPoll provides a Traffic Monitor that displays the\n"
"incoming and outgoing traffic for this MPoll session. Also, the\n"
"Members button will display of list of people currently running MPoll\n"
"for this session.\n"
"\n"
"The Save Results button will write a text file in your home directory\n"
"that summarizes all the questions and results.  This file is human-\n"
"readable and could also be used as input to a data analysis program.\n"
"\n"
"The Quit button will stop MPoll.  MPoll creates a cache file in your\n"
"home directory to save the questions from your last MPoll session so\n"
"your questions and responses are reloaded automatically.\n"
"\n"
"Shortcuts:\n"
"- double-click Button 1 (left) on a topic to view a question\n"
"- single-click Button 3 (right) on a topic to view the results\n"
"\n"
"}\n"
"}\n"
"\n"
"proc help_quest {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{This window displays the question for a topic and all the available\n"
"responses.   You answer a question by clicking Button 1 (left) on one\n"
"of the response buttons, and then pressing the \"Submit Your Response\"\n"
"button.  Your response is immediately sent to everyone who is using\n"
"this MPoll session, and periodically repeated for late joiners as long\n"
"as you have MPoll running.\n"
"\n"
"Also displayed are the author and creation date for this\n"
"question.  In addition, the Response Life Time (the time that a\n"
"response will be considered valid when calculating the results) is\n"
"shown, and a message will appear if your previous response has\n"
"expired.  \n"
"\n"
"You can view the results received so for by pressing the \"View\n"
"Results\" button.\n"
"\n"
"}\n"
"}\n"
"\n"
"proc help_create {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{This window is used to create new questions. When a question is\n"
"created, it is sent to all users immediately and repeated\n"
"periodically for late joiners as long as you have MPoll running.  The\n"
"fields required to create a question are:\n"
"\n"
"- a short \"question topic\", which is used for the topic display in\n"
"the main window\n"
"\n"
"- the poll question that you want users to answer.  Make sure that\n"
"your question is understandable.\n"
"\n"
"- the possible responses for your question.  You can offer up to 10\n"
"possible responses.  Make sure that each response is\n"
"understandable.  (Shortcut: use TAB to move between responses.)\n"
"\n"
"There are also two question options:\n"
"\n"
"- the number of responses allowed.  \n"
"\n"
"Simple multiple-choice questions only allow one response (e.g.,\n"
"\"Yes\" or \"No\"), while other questions may allow more than one\n"
"response (e.g., all the opinions you agree with).\n"
"\n"
"- the response life time, expressed in minutes.  \n"
"\n"
"For some question, such as collecting quality ratings during an\n"
"MBone session, you may only be interested in recent responses. \n"
"Here you might select a short Response Life Time (e.g., 15\n"
"minutes) so only recent responses are counted in the results.\n"
"When a response is older than the response life time, it will be\n"
"deleted from the results and the users will be reminded to\n"
"answer the question again.\n"
"\n"
"For other questions you may want to include all responses made\n"
"during an MPoll session.  A Response Life Time of 0 (zero)\n"
"represents an infinite life time, so responses never expire.\n"
"\n"
"Once you have entered all the fields and selected the options, press\n"
"the \"Create Question\" button.\n"
"}\n"
"}\n"
"\n"
"proc help_results {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{This window presents a graphical display of the responses received\n"
"for a question.  Each data bar represents the precentage of users\n"
"giving that response, and the actual response count is shown at the\n"
"top of the bar.  In addition, the total number of responses is shown\n"
"at the top of the graph.\n"
"\n"
"The results display is updated automatically at regular intervals.\n"
"}\n"
"}\n"
"\n"
"\n"
"proc help_string_results {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{This window presents a text display of the responses received for a\n"
"question.  Each response to the question is listed in the window,\n"
"separated from the previous response by \"---\" characters.\n"
"\n"
"To provide stability during reading of the responses, the results\n"
"display is not updated automatically and you should press the\n"
"\"Update\" button to get the latest responses.\n"
"}\n"
"}\n"
"\n"
"\n"
"proc help_monitor {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{The Traffic Monitor displays the incoming and outgoing multicast\n"
"traffic for this MPoll session.  Traffic that is displayed here\n"
"includes:\n"
"\n"
"- incoming questions from other users\n"
"- incoming responses from other users\n"
"- outgoing questions that you created\n"
"- outgoing responses that you selected\n"
"\n"
"The traffic monitor window is cleared each time it is closed because\n"
"the report can grow quickly.\n"
"\n"
"}\n"
"}\n"
"\n"
"proc help_members {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{The Members window displays the current members of this MPoll\n"
"session.  The membership list is updated periodically and should be\n"
"a good indication of who is currently running MPoll for this session.\n"
"\n"
"The \"Keep All\" option button causes all members to be displayed in\n"
"this  window, even if they are no longer using the session.  Members\n"
"no longer using the session are listed in gray text.\n"
"\n"
"}\n"
"}\n"
"\n"
"proc help_log {} {\n"
"\n"
".help.top.textwin insert 0.0 \\\n"
"{This logging window displays debugging information.\n"
"\n"
"}\n"
"}\n"
"\n"
"\n"
"";
#line 136 "mpoll.c"
Et_EvalInclude("help.tcl",_ET_script_); };
   
   init_bitmaps(); /* setup bitmaps used by TCL */
  
   /* setup the shared C/TCL variables */
   /* do it while the char pointers are NULL */
   
   Tcl_LinkVar(Et_Interp, "theme", (char *)&theme, TCL_LINK_STRING);
   theme = strdup("Unknown Theme"); /* a default */
   
   Tcl_LinkVar(Et_Interp, "version", (char *)&version, TCL_LINK_STRING);
   version = (char *)malloc(256);
   sprintf(version, "Beta %s", vernum);
   
   Tcl_LinkVar(Et_Interp, "summary", (char *)&current_summary, TCL_LINK_STRING);
   current_summary = (char *)malloc(TMPSTRLEN);
   
   Tcl_LinkVar(Et_Interp, "question", (char *)&current_question, TCL_LINK_STRING);
   current_question = (char *)malloc(QUESTION_SIZE);
   
   Tcl_LinkVar(Et_Interp, "author", (char *)&current_author, TCL_LINK_STRING);
   current_author = (char *)malloc(TMPSTRLEN);
   
   Tcl_LinkVar(Et_Interp, "create_time", (char *)&current_time, TCL_LINK_STRING);
   current_time = (char *)malloc(TMPSTRLEN);
   
   Tcl_LinkVar(Et_Interp, "option", (char *)&current_option, TCL_LINK_STRING);
   current_option = (char *)malloc(TMPSTRLEN);
   
   Tcl_LinkVar(Et_Interp, "decaytime", (char *)&current_decay, TCL_LINK_INT);
   
   Tcl_LinkVar(Et_Interp, "default_font", (char *)&default_font, TCL_LINK_STRING);
   default_font = strdup(DEFAULT_FONT);

   Tcl_LinkVar(Et_Interp, "small_font", (char *)&small_font, TCL_LINK_STRING);
   small_font = strdup(SMALL_FONT);

   use_defaults = USEDEFAULTS;  
   /* now handle non-ET command line arguments */
   if (argc > 1)
      {
      for (arg = 1; arg < argc; ++arg)
         {
         if ( !strcmp("-C", argv[arg]))
            {
            theme = strdup(argv[arg+1]);
            ++arg;
            }
         else if (!strcmp("-t", argv[arg]))
            {
            ttl = atoi(argv[arg+1]);
            ++arg;
            }
         else if (!strcmp("-D", argv[arg]))
            {
            use_defaults = 1;
            }
         else if (!strcmp("-V", argv[arg]))
            {
            printf("%s\n", version);
            exit(1);
            }
         else if (!strcmp("-l", argv[arg]))
            {
            logging = 1;
            }
         else if (!strcmp("-s", argv[arg]))
            {
            simulate = 1;
            }
         else if (!strncmp("2", argv[arg], 1))
            {
            address = strdup(argv[arg]);
            
            if (strchr(address, '/') == NULL)
               {
               usage("Multicast address and port needed.");
               }
            
            /* terminate the address string */
            address_end = address;
            while (*address_end != '\0' && *address_end != '/')
               {
               ++address_end;
               }
            *address_end = '\0';
            port = atoi(address_end + 1);
            }
         else
            {
            sprintf(messbuf, "Unknown command line argument: %s\n", argv[arg]);
            usage(messbuf);
            }
         }
      }
      
   /* open logging window */
   if (logging)
      viewlog();
   
   
   /* create the sockets */
   if (! ttl)
      {
      ttl = DEFAULT_TTL;
      }
   if (use_defaults)
      {
      if (address == NULL)
         {
         address = strdup(DEFAULT_ADDRESS);
         }
      if (! port)
         {
         port = DEFAULT_PORT;
         }
      }
   
   if ((address && port && ttl) == 0)
      usage("Command parameter missing");
         
   init_socket();
   
   /* setup temporary parsing variables */
   
   setparsevars();
   
   /* read in the data from cache file*/
   readdata(); 
   
   /* the main TCL topics window is created here */ 
   { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"option add *font \\\n"
"\"$default_font\" \\\n"
"widgetDefault\n"
"\n"
"wm title . \"MPoll - $theme\"\n"
"wm iconbitmap . \"point\"\n"
"\n"
"frame .topbar \\\n"
"-borderwidth 1 \\\n"
"-relief flat\n"
"pack .topbar -side top \n"
"\n"
"button .topbar.about \\\n"
"-text \"About\" \\\n"
"-command  \"helpme about\" -font fixed\n"
"pack .topbar.about -side  right\n"
"\n"
"button .topbar.help \\\n"
"-text \"Help\" \\\n"
"-command  \"helpme topics\" -font fixed\n"
"pack .topbar.help -side  right\n"
"\n"
"button .topbar.monitor \\\n"
"-text \"Traffic Monitor\" \\\n"
"-command  \"viewmonitor\" -font fixed\n"
"pack .topbar.monitor -side  right\n"
"\n"
"button .topbar.members \\\n"
"-text \"Members\" \\\n"
"-command  \"viewmembers\" -font fixed\n"
"pack .topbar.members -side  right\n"
"\n"
"\n"
"\n"
"label .mlabel \\\n"
"-text  \"TOPICS FOR: $theme\" \\\n"
"-fg  blue -font fixed\n"
"pack .mlabel -side top -padx 5 -anchor w\n"
"\n"
"\n"
"\n"
"frame .listframe\n"
"pack .listframe -side top -expand  1 -fill  y\n"
"\n"
"frame .listframe.buttonframe\n"
"pack .listframe.buttonframe -side  right\n"
"\n"
"button .listframe.buttonframe.viewbutton \\\n"
"-text  \"View Question\" \\\n"
"-width  15 \\\n"
"-command viewquest -font fixed\n"
"pack .listframe.buttonframe.viewbutton -anchor  w\n"
"\n"
"button .listframe.buttonframe.resultsbutton \\\n"
"-text  \"View Results\" \\\n"
"-width  15 \\\n"
"-command quickviewresults -font fixed\n"
"pack .listframe.buttonframe.resultsbutton -anchor  w\n"
"\n"
"button .listframe.buttonframe.createbutton \\\n"
"-text  \"Create Question\" \\\n"
"-width  15 \\\n"
"-command  createq -font fixed\n"
"pack .listframe.buttonframe.createbutton -anchor  w\n"
"\n"
"button .listframe.buttonframe.deletebutton \\\n"
"-text  \"Delete Question\" \\\n"
"-width  15 \\\n"
"-command  deleteq -font fixed\n"
"pack .listframe.buttonframe.deletebutton -anchor  w\n"
"\n"
"scrollbar .listframe.listscroll \\\n"
"-orient vertical \\\n"
"-command  [list .listframe.list yview]\n"
"\n"
"listbox .listframe.list \\\n"
"-yscrollcommand  [list .listframe.listscroll set] \\\n"
"-setgrid  1 \\\n"
"-height  10 \\\n"
"-width  30 -font fixed\n"
"\n"
"\n"
"bind .listframe.list <Double-Button-1> \"viewquest\"\n"
"\n"
"\n"
"bind .listframe.list <Button-3> {.listframe.list select clear 0 end}\n"
"bind .listframe.list <Button-3> {+ .listframe.list select anchor [.listframe.list nearest %y]}\n"
"bind .listframe.list <Button-3> {+ .listframe.list select set anchor [.listframe.list nearest %y]}\n"
"bind .listframe.list <Button-3> {+ quickviewresults}\n"
"\n"
"pack .listframe.listscroll -side right  -fill y  -expand  1\n"
"pack .listframe.list -side  left  -expand 1  -fill both\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"frame .bottomframe \n"
"pack .bottomframe -pady 0 -padx 5 -side bottom -fill  x\n"
"\n"
"label .bottomframe.logo \\\n"
"-bitmap \"logo\" \\\n"
"-fg blue -font fixed\n"
"\n"
"pack .bottomframe.logo -side left -anchor e\n"
"\n"
"label .bottomframe.version \\\n"
"-text \"MPoll - $version\" -font fixed\n"
"pack .bottomframe.version -side left -ipadx 5\n"
"\n"
"button .bottomframe.quit \\\n"
"-text \"Quit\" \\\n"
"-command  \"confirm\" -font fixed\n"
"pack .bottomframe.quit -side  right\n"
"\n"
"button .bottomframe.save \\\n"
"-text \"Save Results\" \\\n"
"-command  \"saveresults\" -font fixed\n"
"pack .bottomframe.save -side  right\n"
"\n"
"";
#line 267 "mpoll.c"
Et_EvalInclude("topics.tcl",_ET_script_); };
   
   /* and then we populate it with the list of topics */
   listtopics();
   
   /* prepare to interrupt when something on the receive socket */

#ifdef WIN32
   Tcl_CreateFileHandler(Tcl_GetFile((ClientData)recvsock, TCL_WIN_SOCKET), TK_READABLE, (Tcl_FileProc*)hear, (ClientData)recvsock);
#elif IRIX
   Tcl_CreateFileHandler(recvsock, TK_READABLE, (Tcl_FileProc*)hear, (ClientData)recvsock);
#else
   Tcl_CreateFileHandler(Tcl_GetFile((ClientData)recvsock, TCL_UNIX_FD), TK_READABLE, (Tcl_FileProc*)hear, (ClientData)recvsock);
#endif

   /* queue my questions in the cache for retransmission */
   queue_all_questions();
   
   /* get set for retransmission of responses*/
   queue_all_responses();
   
   /* start sending out the membership packets */
   queue_member();
   
   /* This is the song that never ends... */
#ifndef WIN32   
   Et_MainLoop();
#endif
   
   }

/* -------------------------------------------------------------- */
/* show the list of topics */
listtopics()
   {
   int i;
   
   
   /* clear the list of topics */
   Et_Eval(__FILE__,__LINE__,"s",".listframe.list delete 0 end");
   Et_Eval(__FILE__,__LINE__,"s","update idletasks");
   
   /* build the list */
   
   for(i = 1; i <= numtopics; i++)
      {
      Et_Eval(__FILE__,__LINE__,"sss",".listframe.list insert end \"",(topiclist[i].summary),"\"");
      }
   Et_Eval(__FILE__,__LINE__,"s","update idletasks");
   
   
   }
/* -------------------------------------------------------------- */
/* mark a topic as deleted */
static int Et_Proc_deleteq(void *clientData,struct Tcl_Interp *interp,int argc,char **argv)
   {
   char sw[512];
   char *swp = sw;
   char *remoteadd, *remoteuser;
   unsigned long remoteip;   
   int confbutton;
   int i;
   int deltopic;

   /* find out which topic has been selected */
   swp = Et_EvalString(__FILE__,__LINE__,"ss","\n"
,".listframe.list curselection\n"
);
      
   /* make sure there is something there */
   if (strcmp(swp, "") == 0)
      {
      Et_Eval(__FILE__,__LINE__,"ssssssss","\n"
,"bell\n"
,"tk_dialog .viewdialog \\\n"
,"\"Error\" \\\n"
,"\"You must select a topic\" \\\n"
,"\"error\" \\\n"
,"0 \\\n"
,"\"Return\"\n"
);
      return ET_OK;
      }
      
   deltopic = atoi(swp) + 1; /* master structure starts at 1 */
   
   /* check to see that this is one of our topics */
   
   remoteadd = getword(topiclist[deltopic].qid, 2);
   remoteip = inet_addr(remoteadd);
   remoteuser = getword(topiclist[deltopic].qid, 1);
   
   if (
      (remoteip != hostaddr) ||
      (strcmp(remoteuser, username) != 0)
      )
      {
      logger("user tried to delete question they did not create");
      Et_Eval(__FILE__,__LINE__,"sssssss","\n"
,"tk_dialog .deletedialog \\\n"
,"\"Question Not Deleted\" \\\n"
,"\"You did not create that question, so you cannot delete it.\" \\\n"
,"\"error\" \\\n"
,"0 \\\n"
,"\"Dismiss\"\n"
);
      free(remoteadd);
      free(remoteuser);
      return ET_OK;
      }
      
   free(remoteadd);
   free(remoteuser);

   /* make sure they really want to delete this */   
   confbutton = Et_EvalInt(__FILE__,__LINE__,"ssssqssss","\n"
,"tk_dialog .dialog1 \\\n"
,"\"Confirm Delete\" \\\n"
,"\"Do you really want to delete the question: ",(topiclist[deltopic].summary),"?\" \\\n"
,"\"question\" \\\n"
,"0 \\\n"
,"\"Yes\"  \"No\"\n"
);
   if (confbutton == 1)
      {
      return ET_OK;
      }
   
   /* send out the delete_question packet */
   numdeleted++;
   memcpy(&deltopics[numdeleted], &topiclist[deltopic], sizeof(struct topic));
   queue_question_delete(numdeleted);
   
   /* get rid of the local copy */
   /* shuffle all higher topics down one */
   for (i = deltopic; i < numtopics; i++)
      {
      memcpy(&topiclist[i], &topiclist[i+1], sizeof(struct topic));
      }
   /* reset the last space to zero */
   memset(&topiclist[numtopics], 0, sizeof(struct topic));
   numtopics--;
   
   /* update the cache file */
   writedata();
   
   /* update the display of topics */
   listtopics();
   
   
   return ET_OK;     
   }
  
/* -------------------------------------------------------------- */
/* view the details of the topic, and allow user to respond */

int quest(int thistopic)
   {
   int i, j, foundresponse;
   int k;
   int hasexpired;
   char *optiontext = NULL;
   time_t tmptime;
   time_t now, ntpnow;
   long int tdiff;

   /* if a question window exists, get rid of it */
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .qmain") != 0)
      {
      Et_Eval(__FILE__,__LINE__,"s","destroy .qmain");
      }
      
   /* if a results window exists, get rid of it */
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .rmain") != 0)
      {
      Et_Eval(__FILE__,__LINE__,"s","destroy .rmain");
      }
      
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .textmain") != 0)
      {
      Et_Eval(__FILE__,__LINE__,"s","destroy .textmain");
      }
      
   /* get the relevant data into the shared TCL variables */
   strcpy(current_summary, topiclist[thistopic].summary);
   strcpy(current_question, topiclist[thistopic].question);
   strcpy(current_author, topiclist[thistopic].email);
   strcpy(current_option, topiclist[thistopic].option);
   current_decay = topiclist[thistopic].decay_time;
   
   /* printf("Thistopic set to %d\n", thistopic); */
   Et_Eval(__FILE__,__LINE__,"sd","set tcltopic ",(thistopic));
   
   
   tmptime = ntptounix(topiclist[thistopic].time);
   strcpy(current_time , ctime(&tmptime));
   
   /* now display the question details */
   { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"toplevel .qmain\n"
"\n"
"wm title .qmain \"$summary\"\n"
"\n"
"label .qmain.topicnum \\\n"
"-text  \"Topic: $summary\" \\\n"
"-fg  \"blue\" -font fixed\n"
"pack .qmain.topicnum -pady  2\n"
"\n"
"message .qmain.question \\\n"
"-text \"$question\" \\\n"
"-justify  \"left\" \\\n"
"-width  \"300\" -font fixed\n"
"pack .qmain.question\n"
"\n"
"\n"
"\n"
"\n"
"frame .qmain.optionframe \\\n"
"-borderwidth 2\n"
"pack .qmain.optionframe -pady 0\n"
"\n"
"\n"
"\n"
"\n"
"frame .qmain.butframe\n"
"pack .qmain.butframe -pady 0\n"
"\n"
"frame .qmain.expireframe\n"
"pack .qmain.expireframe -pady 0\n"
"\n"
"\n"
"message .qmain.decay \\\n"
"-text \"Response Life Time: $decaytime minutes\" \\\n"
"-justify  center \\\n"
"-width  300  -font fixed\n"
"pack .qmain.decay \n"
"\n"
"\n"
"\n"
"frame .qmain.authorframe\n"
"pack .qmain.authorframe -side top  -fill  \"x\" -pady 0\n"
"\n"
"\n"
"message .qmain.authorframe.author \\\n"
"-text \"Created by $author\" \\\n"
"-justify center \\\n"
"-width 600 -font fixed\n"
"pack .qmain.authorframe.author -side top\n"
"\n"
"message .qmain.authorframe.date \\\n"
"-text \"On $create_time\" \\\n"
"-justify center \\\n"
"-width 600 -font fixed\n"
"pack .qmain.authorframe.date -side top\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"frame .qmain.bottomframe\n"
"pack .qmain.bottomframe -side \"bottom\"  -fill  \"x\" -pady 1\n"
"\n"
"button .qmain.bottomframe.submit \\\n"
"-text \"Submit Response\" \\\n"
"-command \"submit $tcltopic\" -font fixed\n"
"pack .qmain.bottomframe.submit -side  \"left\"\n"
"\n"
"button .qmain.bottomframe.results \\\n"
"-text \"View Results\" \\\n"
"-command \"viewresults $tcltopic\" -font fixed\n"
"pack .qmain.bottomframe.results -side  \"left\"  -padx 0\n"
"\n"
"button .qmain.bottomframe.dismiss \\\n"
"-text \"Dismiss\" \\\n"
"-command {destroy .qmain} -font fixed\n"
"pack .qmain.bottomframe.dismiss -side  \"right\"\n"
"\n"
"button .qmain.bottomframe.help \\\n"
"-text  \"Help\" \\\n"
"-command {helpme quest} -font fixed\n"
"pack .qmain.bottomframe.help -side right\n"
"\n"
"\n"
"\n"
"";
#line 465 "mpoll.c"
Et_EvalInclude("quest.tcl",_ET_script_); };
   
   /* clear out all the old button variables */
   for (i = 1; i <= MAX_RESPONSES; i++)
      {
      if (Et_EvalInt(__FILE__,__LINE__,"sd","info exists button",(i)))
         {
         Et_Eval(__FILE__,__LINE__,"sd","unset button",(i));
         }
      }
      
   /* tell user how many responses are possible */
   
   if (strcmp(topiclist[thistopic].option, "text") == 0)
      {
      optiontext = strdup("Type Your Response");
      }
   else if (strcmp(topiclist[thistopic].option, "many") == 0)
      {
      optiontext = strdup("Select One or More Responses");
      }
   else
      {
      optiontext = strdup("Select One Response");
      }
   
   Et_Eval(__FILE__,__LINE__,"sssqssss","\n"
,"message .qmain.optionframe.message \\\n"
,"-text \"",(optiontext),"\" \\\n"
,"-width \"300\" \\\n"
,"-fg \"green4\" -font fixed\n"
,"pack .qmain.optionframe.message -in .qmain.optionframe \n"
);

   free(optiontext);
         
   foundresponse = 0; 
   hasexpired = 0;  
   for (j = 1; j <= nummyresponses; j++)
      {
      if (strcmp(myresponse[j].id, topiclist[thistopic].qid) == 0)
         {
         foundresponse = 1;
         break;
         /* j will be index to appropriate my response */
         }
      }
      
   /* match my response to global response list */
   if (foundresponse)
      {   
      /* lookup if this is expired or not */
      if (topiclist[thistopic].decay_time != 0)
         {
         time(&now);
         ntpnow = unixtontp(now);
         tdiff = ntpnow - myresponse[j].time;

         /* life time expressed in minutes so multiply by 60 */
         if (tdiff > (topiclist[thistopic].decay_time * DECAY_FACTOR))
            {
            hasexpired = 1;
            }
         }
      }
      
   
   /* now populate the display with the responses */
   
   if (strcmp(topiclist[thistopic].option, "text") == 0)
      {
      /* create an input box */
      Et_Eval(__FILE__,__LINE__,"ssssss","\n"
,"text .qmain.butframe.textwin \\\n"
,"-width 40 \\\n"
,"-height 10 \\\n"
,"-wrap \"word\"  -font fixed\n"
,"pack .qmain.butframe.textwin -side \"top\"\n"
);
         
      /* put old response in input box */
      if (foundresponse)
         {
         Et_Eval(__FILE__,__LINE__,"ssqs","\n"
,".qmain.butframe.textwin insert end \"",(myresponse[j].response[1]),"\\n\"\n"
);
         }
      }
   else
      {
      for (i = 1; i <= MAX_RESPONSES; i++)
         {
         int butnum = 0;
         if (topiclist[thistopic].response[i] != NULL)
            {

            /* multiple responses */
            if (strcmp(topiclist[thistopic].option, "many") == 0)
               {
               butnum = i;

               if (foundresponse)
                  {
                  /* set the variables to the previous responses */
                  for (k = 1; k <= MAX_RESPONSES ; k++)
                     {
                     if ((myresponse[j].response[butnum] != NULL) && (topiclist[thistopic].response[k] != NULL))
                        {
                        if (strcmp(myresponse[j].response[butnum], topiclist[thistopic].response[k]) == 0)
                           {
                           Et_Eval(__FILE__,__LINE__,"sdsds","set button",(k)," \"",(k),"\"");
                           break;
                           }
                        }
                     }
                  }


               Et_Eval(__FILE__,__LINE__,"ssdssdssdssqss","\n"
,"checkbutton .qmain.butframe.button",(i)," \\\n"
,"-variable \"button",(butnum),"\" \\\n"
,"-onvalue \"",(i),"\" \\\n"
,"-text \"",(topiclist[thistopic].response[i]),"\" \\\n"
,"-fg red -font fixed\n"
);
              }


            /* single response */
            else
               {
               /* force the same button variable for all buttons */
               butnum = 1;

               if (foundresponse)
                  {
                  /* set the variable to the previous response */
                  for (k = 1; k <= MAX_RESPONSES ; k++)
                     {
                     if (strcmp(myresponse[j].response[1], 
                        topiclist[thistopic].response[k]) == 0)
                           {
                           break;
                           /* k will be right response number */
                           }
                     }
                  Et_Eval(__FILE__,__LINE__,"sdsds","set button",(butnum)," \"",(k),"\"");
                  }

               Et_Eval(__FILE__,__LINE__,"ssdssdssdssqss","\n"
,"radiobutton .qmain.butframe.button",(i)," \\\n"
,"-variable \"button",(butnum),"\" \\\n"
,"-value \"",(i),"\" \\\n"
,"-text \"",(topiclist[thistopic].response[i]),"\" \\\n"
,"-fg red -font fixed\n"
);
               }


            Et_Eval(__FILE__,__LINE__,"ssds","\n"
,"pack .qmain.butframe.button",(i)," -side top -anchor w\n"
);
            }
        } /* button loop */
     }
     
   if (hasexpired)
      {
      Et_Eval(__FILE__,__LINE__,"sssssss","\n"
,"message .qmain.expireframe.expired \\\n"
,"-text \"Your response has expired, please submit again.\" \\\n"
,"-fg \"orange2\" \\\n"
,"-justify center \\\n"
,"-width 600 -font fixed\n"
,"pack .qmain.expireframe.expired -in .qmain.expireframe -side top\n"
);
      }
   }
   
/* -------------------------------------------------------------- */
/* the interface to create a new question */

static int Et_Proc_createq(void *clientData,struct Tcl_Interp *interp,int argc,char **argv)   
   {
   int typebutton;
   
   /* reset all the Tcl variables */
   strcpy(current_summary, "");
   strcpy(current_question, "");
   strcpy(current_author, "");
   strcpy(current_time, "");
   current_decay = 0;
   
   
   /* find out the type of question */
   
   typebutton = Et_EvalInt(__FILE__,__LINE__,"sssssss","\n"
,"tk_dialog .qtype \\\n"
,"\"What type of question?\" \\\n"
,"\"What type of question are you creating?\" \\\n"
,"\"question\" \\\n"
,"0 \\\n"
,"\"Multiple Choice\" \"Text\"\n"
);
   
   /* if multi choice */
   if (typebutton == 0)
      {
      { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc forceLen {len name el op} {\n"
"global $name ${name}_len\n"
"if [string comp $el {}] {\n"
"set old  ${name}_len\\($el)\n"
"set name $name\\($el)\n"
"} else { set old ${name}_len }\n"
"if {[string length [set $name]] > $len} {\n"
"set $name [set $old]\n"
"bell; return\n"
"}\n"
"set $old [set $name]\n"
"}\n"
"\n"
"\n"
"\n"
"toplevel .cmain\n"
"wm title .cmain \"$theme\"\n"
"\n"
"label .cmain.title \\\n"
"-text \"Create a Question for: $theme\" \\\n"
"-fg \"blue\"  -font fixed\n"
"pack .cmain.title\n"
"\n"
"frame .cmain.entryframe\n"
"pack .cmain.entryframe -padx 10\n"
"\n"
"frame .cmain.entryframe.topicframe\n"
"pack .cmain.entryframe.topicframe -pady 10 -anchor \"w\"\n"
"\n"
"label .cmain.entryframe.topicframe.topicprompt \\\n"
"-text \"Topic (40 characters max): \"  -font fixed\n"
"pack .cmain.entryframe.topicframe.topicprompt -side \"top\" -anchor w\n"
"\n"
"set summary {}\n"
"entry .cmain.entryframe.topicframe.topicentry \\\n"
"-width 40 \\\n"
"-textvariable \"summary\"  -font fixed\n"
"pack .cmain.entryframe.topicframe.topicentry -side \"top\"\n"
"trace variable summary w {forceLen 40}\n"
"set summary {}\n"
"\n"
"frame .cmain.entryframe.qframe\n"
"pack .cmain.entryframe.qframe -anchor w\n"
"\n"
"label .cmain.entryframe.qframe.qprompt \\\n"
"-text \"Poll Question: \"  -font fixed\n"
"pack .cmain.entryframe.qframe.qprompt -side \"top\" -anchor \"w\"\n"
"\n"
"text .cmain.entryframe.qframe.textwin \\\n"
"-width 40 \\\n"
"-height 10 \\\n"
"-wrap \"word\"  -font fixed\n"
"pack .cmain.entryframe.qframe.textwin -side \"top\"\n"
"\n"
"label .cmain.entryframe.resplabel \\\n"
"-text \"Possible Responses:\"  -font fixed\n"
"pack .cmain.entryframe.resplabel -anchor \"w\"\n"
"\n"
"\n"
"for {set i 1} {$i <= 10} {incr i 1} \\\n"
"{\n"
"set resp$i \"\"\n"
"\n"
"frame .cmain.entryframe.rframe$i\n"
"pack .cmain.entryframe.rframe$i -anchor w\n"
"\n"
"if {$i < 10} {\n"
"label .cmain.entryframe.rframe$i.count -text \"  $i: \"  -font fixed\n"
"} else {\n"
"label .cmain.entryframe.rframe$i.count -text \"$i: \"  -font fixed\n"
"}\n"
"\n"
"pack .cmain.entryframe.rframe$i.count -side \"left\" -anchor w\n"
"\n"
"set resp$i {}\n"
"entry .cmain.entryframe.rframe$i.entry \\\n"
"-width 35 \\\n"
"-textvariable \"resp$i\"  -font fixed\n"
"pack .cmain.entryframe.rframe$i.entry -side \"right\"\n"
"trace variable resp$i w {forceLen 35}\n"
"set resp$i {}\n"
"}\n"
"\n"
"\n"
"frame .cmain.entryframe.typeframe \\\n"
"-borderwidth 2 \\\n"
"-relief \"raised\" \n"
"pack .cmain.entryframe.typeframe -pady 5 -anchor \"w\"\n"
"\n"
"label .cmain.entryframe.typeframe.manyprompt \\\n"
"-text \"How Many Responses Can Users Choose: \" -font fixed\n"
"pack .cmain.entryframe.typeframe.manyprompt -side \"top\"\n"
"\n"
"set type \"\"\n"
"\n"
"radiobutton .cmain.entryframe.typeframe.onebutton \\\n"
"-variable \"type\" \\\n"
"-text \"one\" \\\n"
"-value \"one\" -font fixed\n"
"pack .cmain.entryframe.typeframe.onebutton -side \"left\"\n"
".cmain.entryframe.typeframe.onebutton select\n"
"\n"
"radiobutton .cmain.entryframe.typeframe.manybutton \\\n"
"-variable \"type\" \\\n"
"-text \"many\" \\\n"
"-value \"many\" -font fixed\n"
"pack .cmain.entryframe.typeframe.manybutton -side \"left\"\n"
"\n"
"\n"
"\n"
"\n"
"frame .cmain.entryframe.decayframe\n"
"pack .cmain.entryframe.decayframe -pady 5 -anchor \"w\"\n"
"\n"
"label .cmain.entryframe.decayframe.decaylabel \\\n"
"-text \"Response Life Time (min): \"  -font fixed\n"
"pack .cmain.entryframe.decayframe.decaylabel -side \"left\"\n"
"\n"
"entry .cmain.entryframe.decayframe.decayentry \\\n"
"-width 5 \\\n"
"-textvariable \"decaytime\" -font fixed\n"
"pack .cmain.entryframe.decayframe.decayentry -side \"left\"\n"
"\n"
".cmain.entryframe.decayframe.decayentry delete 0 end\n"
".cmain.entryframe.decayframe.decayentry insert 0 \"0\"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"frame .cmain.bottomframe\n"
"pack .cmain.bottomframe -side \"bottom\"  -fill  \"x\" -pady 5\n"
"\n"
"button .cmain.bottomframe.create \\\n"
"-text \"Create Question\" \\\n"
"-command addq -font fixed\n"
"pack .cmain.bottomframe.create -side  \"left\"\n"
"\n"
"button .cmain.bottomframe.dismiss \\\n"
"-text \"Dismiss\" \\\n"
"-command {destroy .cmain} -font fixed\n"
"pack .cmain.bottomframe.dismiss -side  \"right\"\n"
"\n"
"button .cmain.bottomframe.help \\\n"
"-text  \"Help\" \\\n"
"-command {helpme create} -font fixed\n"
"pack .cmain.bottomframe.help -side right\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"";
#line 673 "mpoll.c"
Et_EvalInclude("create.tcl",_ET_script_); };
      }
   
   /* if text response */
   else
      {
      { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"proc forceLen {len name el op} {\n"
"global $name ${name}_len\n"
"if [string comp $el {}] {\n"
"set old  ${name}_len\\($el)\n"
"set name $name\\($el)\n"
"} else { set old ${name}_len }\n"
"if {[string length [set $name]] > $len} {\n"
"set $name [set $old]\n"
"bell; return\n"
"}\n"
"set $old [set $name]\n"
"}\n"
"\n"
"\n"
"\n"
"toplevel .cmain\n"
"wm title .cmain \"$theme\"\n"
"\n"
"label .cmain.title \\\n"
"-text \"Create a Question for: $theme\" \\\n"
"-fg \"blue\"  -font fixed\n"
"pack .cmain.title\n"
"\n"
"frame .cmain.entryframe\n"
"pack .cmain.entryframe -padx 10\n"
"\n"
"frame .cmain.entryframe.topicframe\n"
"pack .cmain.entryframe.topicframe -pady 0 -anchor \"w\"\n"
"\n"
"label .cmain.entryframe.topicframe.topicprompt \\\n"
"-text \"Topic (40 characters max): \"  -font fixed\n"
"pack .cmain.entryframe.topicframe.topicprompt -side \"top\" -anchor w\n"
"\n"
"set summary {}\n"
"entry .cmain.entryframe.topicframe.topicentry \\\n"
"-width 40 \\\n"
"-textvariable \"summary\"  -font fixed\n"
"pack .cmain.entryframe.topicframe.topicentry -side \"left\"\n"
"trace variable summary w {forceLen 40}\n"
"set summary {}\n"
"\n"
"frame .cmain.entryframe.qframe\n"
"pack .cmain.entryframe.qframe -anchor w\n"
"\n"
"label .cmain.entryframe.qframe.qprompt \\\n"
"-text \"Poll Question: \"  -font fixed\n"
"pack .cmain.entryframe.qframe.qprompt -side \"top\" -anchor \"w\"\n"
"\n"
"text .cmain.entryframe.qframe.textwin \\\n"
"-width 40 \\\n"
"-height 10 \\\n"
"-wrap \"word\"  -font fixed\n"
"pack .cmain.entryframe.qframe.textwin -side \"top\"\n"
"\n"
"label .cmain.entryframe.resplabel \\\n"
"-text \"Users will enter a text response.\"  -font fixed\n"
"pack .cmain.entryframe.resplabel -side top -pady 1\n"
"\n"
"set type \"text\"\n"
"\n"
"\n"
"\n"
"frame .cmain.entryframe.decayframe\n"
"pack .cmain.entryframe.decayframe -pady 1 -fill x\n"
"\n"
"label .cmain.entryframe.decayframe.decaylabel \\\n"
"-text \"Response Life Time (min): \"  -font fixed\n"
"pack .cmain.entryframe.decayframe.decaylabel -side \"left\" -anchor w\n"
"\n"
"entry .cmain.entryframe.decayframe.decayentry \\\n"
"-width 5 \\\n"
"-textvariable \"decaytime\"  -font fixed\n"
"pack .cmain.entryframe.decayframe.decayentry -side \"left\"\n"
"\n"
".cmain.entryframe.decayframe.decayentry delete 0 end\n"
".cmain.entryframe.decayframe.decayentry insert 0 \"0\"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"frame .cmain.bottomframe\n"
"pack .cmain.bottomframe -side \"bottom\"  -fill  \"x\" -pady 5\n"
"\n"
"button .cmain.bottomframe.create \\\n"
"-text \"Create Question\" \\\n"
"-command addq -font fixed\n"
"pack .cmain.bottomframe.create -side  \"left\"\n"
"\n"
"button .cmain.bottomframe.dismiss \\\n"
"-text \"Dismiss\" \\\n"
"-command {destroy .cmain} -font fixed\n"
"pack .cmain.bottomframe.dismiss -side  \"right\"\n"
"\n"
"button .cmain.bottomframe.help \\\n"
"-text  \"Help\" \\\n"
"-command {helpme create} -font fixed\n"
"pack .cmain.bottomframe.help -side right\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"";
#line 679 "mpoll.c"
Et_EvalInclude("textcreate.tcl",_ET_script_); };
      }
   return ET_OK;
   }

/* -------------------------------------------------------------- */
/* add the new question to the data structure */

static int Et_Proc_addq(void *clientData,struct Tcl_Interp *interp,int argc,char **argv)
   {
   char tmp[1024];
   char *fname = NULL;
   char *tmpp = tmp;
   int curtop, i, j;
   time_t now;
   struct passwd *pass, *getpwnam();
   char nametmp[TMPSTRLEN];
   char *resptmp = NULL;
   char *tmpquestion = NULL;
   
   /* check that we have enough in the data fields to proceed */
   if (strcmp(current_summary, "") == 0)
      {
      Et_Eval(__FILE__,__LINE__,"sssssss","\n"
,"tk_dialog .notopicdialog \\\n"
,"\"No Question Topic\" \\\n"
,"\"You must enter a question topic.\" \\\n"
,"\"error\" \\\n"
,"0 \\\n"
,"\"Dismiss\"\n"
);
      return ET_OK;
      }
      
   tmpquestion = 
     strdup(Et_EvalString(__FILE__,__LINE__,"s",".cmain.entryframe.qframe.textwin get 1.0 end"));
     
   if (strcmp(tmpquestion, "\n") == 0)
      {
      Et_Eval(__FILE__,__LINE__,"sssssss","\n"
,"tk_dialog .noquestiondialog \\\n"
,"\"No Question\" \\\n"
,"\"You must enter a poll question.\" \\\n"
,"\"error\" \\\n"
,"0 \\\n"
,"\"Dismiss\"\n"
);
      free(tmpquestion);
      return ET_OK;
      }
      
   numtopics++; /* adding a new topic */
   curtop = numtopics;
   
   /* get the data from TCL variables */
   
   topiclist[curtop].summary = strdup(current_summary);
   
   /* note: question can have embedded \n chars, and will always
            have \n at the end */
   topiclist[curtop].question = strdup(tmpquestion);
   
   free(tmpquestion);
     
   /* so remove all the \n characters */
   removenl(topiclist[curtop].question);
      
   topiclist[curtop].option = strdup( Et_EvalString(__FILE__,__LINE__,"s","set type"));
   topiclist[curtop].decay_time = current_decay;
   
   /* remind time stuff will be added later */
/*
 *    topiclist[curtop].remind_time = ET_INT(set remindtime);
 */
   topiclist[curtop].remind_time = 0;
   
   
   /* create the question ID */
   /* get the current time */
   time(&now);
   /* convert time to NTP format for storage */
   now = unixtontp(now);
   
   sprintf(tmpp, "%s %s %lu", username, hostip, now);
   topiclist[curtop].qid = strdup(tmpp);
   
   
   /*  perhaps should also read .RTPdefaults */
   /* get the email information from the OS */
#ifndef WIN32   
   pass = getpwnam(username);
   fname = strdup(pass->pw_gecos);
#else
   fname = strdup(username);
#endif
   
   sprintf(nametmp, "%s <%s@%s>", fname, username, hostname);
   free(fname);
   topiclist[curtop].email = strdup(nametmp);
   
   topiclist[curtop].time = now;
   
   /* use NTP time for ID and version */
   topiclist[curtop].version = now;
   
   topiclist[curtop].theme = strdup(theme);
   
   if (strcmp(topiclist[curtop].option, "text") != 0)
      {
      /* get the possible responses for the new question */
      j = 0;
      for (i = 1; i <= MAX_RESPONSES; i++)
         {
         resptmp = strdup( Et_EvalString(__FILE__,__LINE__,"sd","set resp",(i)));
         if (strcmp(resptmp, "") != 0)
            {
            j++;
            topiclist[curtop].response[j] = strdup(resptmp);
            }
         free(resptmp);
         }
      }
      
   /* update the cache file */
   writedata();

   /* update the topic list */
   listtopics();

   /* and send the new question out to the world */   
   send_question_packet(curtop);
      
   /* get rid of the new question window */
   Et_Eval(__FILE__,__LINE__,"s","destroy .cmain");
   
   return ET_OK;
   }


/* -------------------------------------------------------------- */
/* confirm that the user really wants to exit */

static int Et_Proc_confirm(void *clientData,struct Tcl_Interp *interp,int argc,char **argv)   
   {
   int confbutton;
   
   confbutton = Et_EvalInt(__FILE__,__LINE__,"sssssss","\n"
,"tk_dialog .dialog1 \\\n"
,"\"Confirm Exit\" \\\n"
,"\"Do you really want to quit?\" \\\n"
,"\"question\" \\\n"
,"0 \\\n"
,"\"Yes\"  \"No\" \n"
);

   
   if (confbutton == 0)
      {
      /* write the cache data file */
      writedata();
      exit(0); /* normal exit */
      }
   else
      {
      return ET_OK;
      }
   }

/* -------------------------------------------------------------- */
/* a place holder for functions that are missing */

static int Et_Proc_missing(void *clientData,struct Tcl_Interp *interp,int argc,char **argv)   
   {
   Et_Eval(__FILE__,__LINE__,"ssssssss","\n"
,"bell\n"
,"tk_dialog .missdialog \\\n"
,"\"Function is missing\" \\\n"
,"\"Sorry, this function has not been built yet\" \\\n"
,"\"error\" \\\n"
,"0 \\\n"
,"\"Return\"\n"
);
   return ET_OK;
   }
   
   
/* -------------------------------------------------------------- */
/* show command line argument information */

usage( char *message)
   {
   printf("\n\aCommand line error: %s\n", message);
   printf("\nUsage: mpoll [-D] [-s] [-l] [-V] [-t ttl] [-C \"title\"] address/port\n\
    OPTIONS:\n\
      -D  : use default address and port\n\
      -s  : simulate results (useful for demos)\n\
      -V  : print version number and exit\n\
      -l  : print logging information (for debugging)\n\
      -C \"title\" :  the theme title for the questions\n\
      -t ttl : the multicast TTL (default = 15)\n\n");
   exit(2);
   }
   
/* -------------------------------------------------------------- */
/* learn local hostname and user information */

learn_local_info()
   {
   struct hostent *hstent;
#ifndef WIN32   
   uid_t uid;
   struct passwd* pswd;
   struct utsname name;
#else
#define _SYS_NMLN 9
   int uid;
   int nmsize;
   struct utsname {
      char sysname[_SYS_NMLN];
      char nodename[_SYS_NMLN];
      char release[_SYS_NMLN];
      char version[_SYS_NMLN];
      char machine[_SYS_NMLN];
   };
   struct utsname name;
#endif
   struct in_addr myaddr;


   /* find out information about the system */
   uname(&name);
   sprintf(systeminfo, "%s-%s-%s", name.sysname, name.release, name.machine);

   /*find our own address*/
   gethostname(hostname, BUFFER_SIZE);
   if (hostname[0] == '\0') 
      {
      fprintf(stderr, "gethostname failed!\n");
      exit(1);
      }
   hstent=(struct hostent*)gethostbyname(hostname);
   if (hstent == (struct hostent*) NULL) 
      {
      fprintf(stderr, "gethostbyname failed, hostname={%s}\n", hostname);
      exit(1);
      }
      
   /* store away our address in long it format */
   memcpy((char *)&hostaddr, (char *)hstent->h_addr_list[0], hstent->h_length);
   /* hostaddr is already in network byte order from use of gethost */
   
   /* and in IP dotted quad format */
   myaddr.s_addr = hostaddr;
   strcpy(hostip, (char *)inet_ntoa(myaddr));

   /* find the user's username */
   strcpy(username, "-"); /* default */
   
#ifndef WIN32   
   uid=getuid();
   pswd=getpwuid(uid);
   if(pswd != 0)
      {
      strcpy(username, pswd->pw_name);
      }
#else
   nmsize = sizeof(username);
   GetUserName(username, &nmsize);
   sprintf(messbuf, "Win32 username is %s\n", username);
   logger(messbuf);
#endif

   /* get the user's home directory */
   gethomedir();
   
      
	}
	


/******* Automatically generated code follows ********/
#ifdef __cplusplus
#  define EXTERN extern "C"
#else
#  define EXTERN extern
#endif
EXTERN void Et_InstallCommand(char *,int (*)(void*,struct Tcl_Interp*,int,char**));
void Et_Init_mpoll_c(void){
  Et_InstallCommand("deleteq",Et_Proc_deleteq);
  Et_InstallCommand("createq",Et_Proc_createq);
  Et_InstallCommand("addq",Et_Proc_addq);
  Et_InstallCommand("confirm",Et_Proc_confirm);
  Et_InstallCommand("missing",Et_Proc_missing);
}
