/* DO NOT EDIT! 
** This file has been automatically generated from "results.c" */
#ifdef __cplusplus
#  define EXTERN extern "C"
#else
#  define EXTERN extern
#endif
EXTERN int Et_Eval(const char *,int,const char*,...);
EXTERN int Et_EvalInt(const char *,int,const char*,...);
EXTERN char *Et_EvalString(const char *,int,const char*,...);
EXTERN double Et_EvalDouble(const char *,int,const char*,...);
EXTERN void Et_EvalInclude(const char *,char *);
EXTERN void Et_Init(int *, char **);
EXTERN void Et_MainLoop(void);
EXTERN void Et_ReadStdin(void);
EXTERN struct Tcl_Interp *Et_Interp;
EXTERN struct Tk_Window_ *Et_MainWindow;
EXTERN struct _XDisplay *Et_Display;
#define ET_OK 0
#define ET_ERROR 1
#undef EXTERN
#define UNIX 1
#line 1 "results.c"
/*  @(#)results.c	1.5  97/12/23  */

/*
 * Copyright (c) Communications Research Centre, Government of Canada 1997. 
 * All rights reserved.
 * 
 * License is granted to copy and use this software, for research and
 * evaluation purposes, provided that the Communications Research Centre
 * is acknowledged in all documentation pertaining to any such copy or
 * use. The Communications Research Centre grants no other licenses
 * expressed or implied. Title, ownership rights, and intellectual
 * property rights in the software shall remain with the Communications
 * Research Centre.  The Centre's name and the Government of Canada
 * should not be used in any advertising without written permission.
 * 
 * THE COMMUNICATIONS RESEARCH CENTRE MAKES NO REPRESENTATIONS CONCERNING
 * EITHER THE MERCHANTABILITY OF THIS SOFTWARE OR THE SUITABILITY OF
 * THIS SOFTWARE FOR ANY PARTICULAR PURPOSE.  The software is provided
 * "as is" without express or implied warranty of any kind.
 * 
 * These notices must be retained in any copies of any part of this
 * software.
 */


#include "mpoll.h"

int countlist[MAX_RESPONSES+1];
int slice, bar, space, width;
int xorigin = 20; /* where x axis starts */
time_t now, ntpnow;
long int tdiff;
Tcl_TimerToken results_timer_token;
Tcl_TimerToken member_timer_token;

/* this only handles simple bargraph presentations */


/* -------------------------------------------------------------- */
/* create the results GUI for histograms */

showresults(int thistopic)
   {
   int x, i, j;
   int localnum;
   char *txtmp = NULL;
   int totalpix = 270; 
      /* how much of the X axis in the canvas we can work with */


   /* get the label information for this question */
   strcpy(current_summary, topiclist[thistopic].summary);
   strcpy(current_question, topiclist[thistopic].question);
   strcpy(current_author, topiclist[thistopic].email);
   strcpy(current_option, topiclist[thistopic].option);
   
   Tcl_DeleteTimerHandler(results_timer_token);
   
   /* if a results window exists, get rid of it */
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .rmain") != 0)
      {
      Et_Eval(__FILE__,__LINE__,"s","destroy .rmain");
      }
      
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .textmain") != 0)
      {
      Et_Eval(__FILE__,__LINE__,"s","destroy .textmain");
      }
      
   if (strcmp(current_option, "text") == 0)
      {
      { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"toplevel .textmain\n"
"wm title .textmain \"$summary\"\n"
"\n"
"label .textmain.topic \\\n"
"-text \"$summary\" \\\n"
"-fg blue -font fixed\n"
"pack .textmain.topic   \n"
"\n"
"message .textmain.question \\\n"
"-text \"$question\" \\\n"
"-justify  \"left\" \\\n"
"-width  \"300\" \\\n"
"-relief  \"sunken\" -font fixed\n"
"pack .textmain.question\n"
"\n"
"\n"
"\n"
"\n"
"frame .textmain.resultsframe \\\n"
"-borderwidth  2 \\\n"
"-relief  \"flat\"\n"
"pack .textmain.resultsframe -expand yes -fill both\n"
"\n"
"text .textmain.resultsframe.textwin \\\n"
"-width 50 \\\n"
"-height 30 \\\n"
"-yscrollcommand \".textmain.resultsframe.scroll set\" \\\n"
"-wrap \"word\"  -font fixed\n"
"\n"
"scrollbar .textmain.resultsframe.scroll \\\n"
"-orient vertical \\\n"
"-command \".textmain.resultsframe.textwin yview\"\n"
"\n"
"pack .textmain.resultsframe.scroll -side right -fill y\n"
"pack .textmain.resultsframe.textwin -expand yes -fill both\n"
"\n"
"\n"
"\n"
"\n"
"frame .textmain.bottomframe \n"
"pack .textmain.bottomframe -side bottom -pady  2 -fill x\n"
"\n"
"button .textmain.bottomframe.dismiss \\\n"
"-text  \"Dismiss\" \\\n"
"-command {destroy .textmain} -font fixed\n"
"pack .textmain.bottomframe.dismiss -side right\n"
"\n"
"\n"
"button .textmain.bottomframe.help \\\n"
"-text  \"Help\" \\\n"
"-command {helpme string-results} -font fixed\n"
"pack .textmain.bottomframe.help -side right\n"
"\n"
"button .textmain.bottomframe.update \\\n"
"-text  \"Update\" \\\n"
"-command {tcl_update_string_results} -font fixed\n"
"pack .textmain.bottomframe.update -side right\n"
"\n"
"\n"
"\n"
"\n"
"";
#line 72 "results.c"
Et_EvalInclude("string-results.tcl",_ET_script_); };
      
      update_string_results(thistopic);      
      return TCL_OK;
      }
   
         
   /* create the GUI */
   { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"set default_font \"$small_font\"\n"
"\n"
"\n"
"\n"
"toplevel .rmain\n"
"wm title .rmain \"$summary\"\n"
"\n"
"label .rmain.topic \\\n"
"-text \"$summary\" \\\n"
"-fg blue -font fixed\n"
"pack .rmain.topic   \n"
"\n"
"message .rmain.question \\\n"
"-text \"$question\" \\\n"
"-justify  \"left\" \\\n"
"-width  \"300\" \\\n"
"-relief  \"sunken\" \\\n"
"-font fixed\n"
"pack .rmain.question\n"
"\n"
"\n"
"\n"
"\n"
"frame .rmain.canvasframe \\\n"
"-borderwidth  2 \\\n"
"-relief  \"raised\"\n"
"pack .rmain.canvasframe -pady 2\n"
"\n"
"\n"
"\n"
"\n"
"label .rmain.canvasframe.ylabel \\\n"
"-text  \"%\" \\\n"
"-font fixed\n"
"pack .rmain.canvasframe.ylabel -side left\n"
"\n"
"\n"
"\n"
"canvas .rmain.canvasframe.area \\\n"
"-height  \"200\" \\\n"
"-width  \"300\" \n"
"pack .rmain.canvasframe.area -side left\n"
"\n"
"\n"
"\n"
".rmain.canvasframe.area create line   \\\n"
"20 20 \\\n"
"20 175 \\\n"
"-width 2 \n"
"\n"
"for {set i 0} {$i <= 10} {incr i 1} {\n"
"set y [expr 175 -($i*15)]\n"
".rmain.canvasframe.area create line 20 $y 23 $y -width 2\n"
".rmain.canvasframe.area create text 19 $y -text [expr $i*10] -anchor e -font fixed\n"
"}\n"
"\n"
"\n"
"\n"
".rmain.canvasframe.area create line \\\n"
"20 175 \\\n"
"290 175 \\\n"
"-width 2\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"frame .rmain.bottomframe \n"
"pack .rmain.bottomframe -side bottom -pady 0 -fill x\n"
"\n"
"button .rmain.bottomframe.dismiss \\\n"
"-text  \"Dismiss\" \\\n"
"-command {destroy .rmain} -font fixed\n"
"pack .rmain.bottomframe.dismiss -side right\n"
"\n"
"\n"
"button .rmain.bottomframe.help \\\n"
"-text  \"Help\" \\\n"
"-command {helpme results} -font fixed\n"
"pack .rmain.bottomframe.help -side right\n"
"\n"
"\n"
"\n"
"\n"
"";
#line 80 "results.c"
Et_EvalInclude("results.tcl",_ET_script_); };
   
   /* assume that we have all possible responses until 
      we know otherwise */
   localnum = MAX_RESPONSES;
      
   /* now find out how many responses really for this data set */
   for (j = 1; j <= MAX_RESPONSES; j++)
      {
      if (topiclist[thistopic].response[j] == NULL)
         {
         localnum = j - 1;
         break;
         }
      }	
   
   /* calculate the parameters we need */
   slice = totalpix / localnum;
   bar = slice * .67;
   space = slice - bar;
   width = bar / 2;
   
/*
 *    printf("Using these parms: num bars=%d, slice=%d, bar=%d, space=%d, width=%d\n",
 *       localnum, slice, bar, space, width); 
 */
   
   /* label the X axis */
   for (i = 1; i <= localnum; i++)
      {
      x = xorigin + space + width + ((i - 1) * (slice));
      if ((topiclist[thistopic].response[i]) != NULL)
         {
         txtmp = strdup(topiclist[thistopic].response[i]);
         }
      if (! txtmp)
         {
         return(0);
         }
      Et_Eval(__FILE__,__LINE__,"ssdssqssssdsssdsds","\n"
,".rmain.canvasframe.area create text ",(x)," 179  \\\n"
,"-text  \"",(txtmp),"\" \\\n"
,"-font fixed \\\n"
,"-anchor n \\\n"
,"-width ",(slice)," \\\n"
,"-justify left\n"
,".rmain.canvasframe.area create line ",(x)," 175 ",(x)," 172 -width 1\n"
);
      free(txtmp);
      }
   
   /* draw the data bars */
   drawdata(thistopic);
   
   /* update the Tk display */
   Et_Eval(__FILE__,__LINE__,"s","update idletasks");
   
   /* arrange to update the results periodically */
   update_results(thistopic);
   
   return(0);     
   }
   
   
/* -------------------------------------------------------------- */
/* update the results display periodically */

update_results(int thistopic)
   {
   int status;
   int interval;
   
   
   /* check that we still have a results window */
   status = Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .rmain");
   if (! status)
      {
      Tcl_DeleteTimerHandler(results_timer_token);
      return(0);
      }
      
   /* get rid of the old data */
   Et_Eval(__FILE__,__LINE__,"s",".rmain.canvasframe.area delete update");
   
   /* and put in the new data */
   drawdata(thistopic);
   
   /* and update the Tk display */
   Et_Eval(__FILE__,__LINE__,"s","update idletasks");
   
   /* handler uses msecs so ... */
   interval = UPDATE_TIME * 1000; 
   
   /* use faster updates if this is a simulation */
   if (simulate)
      {
      interval = 1000;
      }
   
   /* infinite loop to this same function */
   results_timer_token =  Tcl_CreateTimerHandler(interval, 
     (Tk_TimerProc*)update_results, (ClientData)thistopic);
   
   }

/* -------------------------------------------------------------- */
/* update the display of the text results */
update_string_results(int thistopic)
   {
   int i;
   
   Et_Eval(__FILE__,__LINE__,"ss","\n"
,".textmain.resultsframe.textwin delete 1.0 end\n"
);
      
   /* populate window with responses */
   /* .textmain.resultsframe.textwin */
   for (i = 1; i <= numresponses; i++)
      {
      /* match the ID */
      if (strcmp(topiclist[thistopic].qid, responselist[i].id) != 0)
         {
         continue;
         }

      /* check for decay */

      if (topiclist[thistopic].decay_time != 0)
         {
         time(&now);
         ntpnow = unixtontp(now);
         tdiff = ntpnow - responselist[i].time;

         /* life time expressed in minutes so multiply by 60 */
         if (tdiff > (topiclist[thistopic].decay_time * DECAY_FACTOR))
            {
            continue;
            }
         }

      Et_Eval(__FILE__,__LINE__,"ssqss","\n"
,".textmain.resultsframe.textwin insert end \"",(responselist[i].response[1]),"\\n\"\n"
,".textmain.resultsframe.textwin insert end \"---\\n\"\n"
);
      }
            
   
   }   
/* -------------------------------------------------------------- */
/* counts up the results for a topic on the fly */
int *count_data(int tnum)
   {
   int i, j, k;
   char *thisresponse = NULL;
   static int simcountlist[MAX_TOPICS + 1][MAX_RESPONSES + 1];
   int simincrease;
   
   /* reset the counter to zeros */
   for (j = 0; j <= MAX_RESPONSES; j++)
      {
      countlist[j] = 0;
      }

   for (i = 1; i <= numresponses; i++)
      {
      /* match the ID */
      if (strcmp(topiclist[tnum].qid, responselist[i].id) != 0)
         {
         continue;
         }
      
      /* check for decay */
      
      if (topiclist[tnum].decay_time != 0)
         {
         time(&now);
         ntpnow = unixtontp(now);
         tdiff = ntpnow - responselist[i].time;

         /* life time expressed in minutes so multiply by 60 */
         if (tdiff > (topiclist[tnum].decay_time * DECAY_FACTOR))
            {
            continue;
            }
         }
      
      
      /* add up the count */
      
      for (j = 1; j <= MAX_RESPONSES; j++)
         {
         if ((responselist[i].response[j]) != NULL)
            {
            thisresponse = strdup(responselist[i].response[j]);
            for (k = 1; k <= MAX_RESPONSES; k++)
               {
               if (topiclist[tnum].response[k] != NULL)
                  {
                  if (strcmp(thisresponse, topiclist[tnum].response[k]) == 0)
                     {
                     /* found out where to put the data */
                     countlist[k]++;
                     }
                  }
               } /* k loop */
            free(thisresponse);
            }
         } /* j loop */
         
      countlist[0]++; /* count of number of responders */

      } /* end of response loop */
      
      
   /* added hack to simulate data for demo purposes */
   if (simulate)
      {
      for (k = 1; k <= MAX_RESPONSES; k++)
         {
         if (topiclist[tnum].response[k] != NULL)
            {
            /* create a bias in the simulated results */
            simincrease = rand() / (RAND_MAX / MAX_RESPONSES - k + 1);
            if (k < 3)
               {
               simincrease *= 2;
               }
            simcountlist[tnum][k] += simincrease;
            countlist[k] += simcountlist[tnum][k];
            simcountlist[tnum][0] += simincrease;
            }
         }
      countlist[0] += simcountlist[tnum][0];
      }
      
   /* return data values */
   return countlist;
      
   }
   

/* -------------------------------------------------------------- */
/* draw the data bar on the results screen */

drawdata(int thistopic)
   {
   int grandtotal = 0;
   int x;
   int i, j;
   int lnum = MAX_RESPONSES;
   char *utime = NULL;
   int *cdata;
   
   /* printf("Drawing data for topic %d\n", thistopic); */
   
   /* find out how many responses for this data set */
   for (j = 1; j <= MAX_RESPONSES; j++)
      {
      if (topiclist[thistopic].response[j] == NULL)
         {
         lnum = j - 1;
         break;
         }
      }	
   
   cdata = count_data(thistopic);
      
   /* calculate the total number of responses */
   grandtotal = cdata[0];  
   

   /* now plot each data bar */
   for (i = 1; i <= lnum; i++)
      {
      x = xorigin + space + width + ((i - 1) * (slice));
      databar(x, cdata[i], grandtotal); 
      }

   /*  get the date  */
   time(&now);
   utime = strdup(ctime(&now));
   linetostr(utime); /* get rid of \n */
   
/* get the status information on the screen */   
/*
 *    
 *    ET(
 *       .rmain.canvasframe.area create text \
 *         55 7 \
 *          -text "Updated: %s(utime)" \
 *          -font "%q(default_font)" \
 *          -tags "update"
 * 
 *       .rmain.canvasframe.area create text \
 *          150 7 \
 *          -text "Total Responses: %d(grandtotal)" \
 *          -font "%q(default_font)" \
 *          -tags "update"
 * 
 *       .rmain.canvasframe.area create text \
 *          250 7 \
 *          -text "Response Life Time: %d(topiclist[thistopic].decay_time)" \
 *          -font "%q(default_font)" \
 *          -tags "update"
 *     );
 */
 
 /* sparse version of status information */
   Et_Eval(__FILE__,__LINE__,"ssssdsss","\n"
,".rmain.canvasframe.area create text \\\n"
,"150 7 \\\n"
,"-text \"Total Responses: ",(grandtotal),"\" \\\n"
,"-font fixed \\\n"
,"-tags \"update\"\n"
);
 
   free(utime);
   }
   
/* -------------------------------------------------------------- */
/* do the actual data bars in the bar graph */

databar(int xpos, int amt, int total)
   {
   float percent;
   int ypos = 175;
   int topy, texty, leftx, rightx;
   
   if (total == 0)
      {
      /* can't divide by zero so bail out */
      return(0);
      }
   
   /* calculate the percent of total for this bar */
   percent = ((float)amt / (float)total)*100;
   
   /* translate into coordinates */
   topy = ypos - (percent * 1.5);
   texty = topy - 5;
   
   leftx = xpos - width;
   rightx = xpos + width;

   
   /* draw the bars */
   Et_Eval(__FILE__,__LINE__,"ssdsdsdsdsssssdsdssdsss","\n"
,".rmain.canvasframe.area create rectangle \\\n"
,(leftx)," ",(ypos)," \\\n"
,(rightx)," ",(topy)," \\\n"
,"-fill red \\\n"
,"-tags update\n"
,"\n"
,".rmain.canvasframe.area create text \\\n"
,(xpos)," ",(texty)," \\\n"
,"-text ",(amt)," \\\n"
,"-font fixed \\\n"
,"-tags update\n"
);
   }
   
   
/* ----------------------------------------------------------- */
/* monitor data traffic flowing in and out */
traffic(char *message)
   {
   char *yview = NULL;
   float first, last;
   
   /* check that the monitor window is open */
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .mmain") == 0)
      {
      return(0);
      }
   Et_Eval(__FILE__,__LINE__,"ssqs","\n"
,".mmain.top.textwin insert end \"",(message),"\\n\"\n"
);
      
      
   /* autoscroll if near the bottom of the window */
   
   yview = strdup(Et_EvalString(__FILE__,__LINE__,"s",".mmain.top.textwin yview"));
   
   sscanf(yview, "%f%f" , &first, &last);
   
   if (last > 0.90)
      {
      Et_Eval(__FILE__,__LINE__,"s",".mmain.top.textwin yview moveto 1");
      }
   free(yview);
   }


/* ------------------------------------------------------------------ */
/* create the member list GUI */
static int Et_Proc_viewmembers(void *clientData,struct Tcl_Interp *interp,int argc,char **argv)
   {
   
   Tcl_DeleteTimerHandler(member_timer_token);
      
    /* if a members window exists, get rid of it */
    
   if (Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .members") != 0)
      {
      Et_Eval(__FILE__,__LINE__,"s","destroy .members");
      }
      
   /* create the GUI */
   { static char _ET_script_[] = 
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"\n"
"if {[winfo exists .members] != 0} {\n"
"destroy .members\n"
"}\n"
"\n"
"\n"
"\n"
"set keep 0\n"
"\n"
"toplevel .members\n"
"\n"
"wm title .members \"MPoll Members\"\n"
"\n"
"\n"
"frame .members.top \\\n"
"-borderwidth  5\n"
"pack .members.top -side  top -expand  1 -fill  y\n"
"\n"
"text .members.top.list \\\n"
"-yscrollcommand  \".members.top.listscroll set\" \\\n"
"-wrap \"word\" \\\n"
"-height  10 \\\n"
"-width  40 -font fixed\n"
"\n"
"scrollbar .members.top.listscroll \\\n"
"-orient vertical \\\n"
"-command  \".members.top.list yview\"\n"
"\n"
"\n"
"pack .members.top.listscroll -side right  -fill y  -expand  1\n"
"pack .members.top.list -side  left  -expand 1  -fill both\n"
"\n"
"\n"
"\n"
"\n"
"frame .members.bottomframe \\\n"
"-borderwidth 1\n"
"pack .members.bottomframe -pady 3 -side bottom -fill  x\n"
"\n"
"button .members.bottomframe.dismiss \\\n"
"-text \"Dismiss\" \\\n"
"-command {destroy .members} -font fixed\n"
"pack .members.bottomframe.dismiss -side  \"right\"\n"
"\n"
"button .members.bottomframe.help \\\n"
"-text  \"Help\" \\\n"
"-command {helpme members} -font fixed\n"
"pack .members.bottomframe.help -side right\n"
"\n"
"checkbutton .members.bottomframe.keep \\\n"
"-text  \"Keep All\" \\\n"
"-variable keep -font fixed\n"
"pack .members.bottomframe.keep -side left\n"
"\n"
"\n"
"\n"
"";
#line 488 "results.c"
Et_EvalInclude("members.tcl",_ET_script_); };
   
   update_members();
   
   return ET_OK;
   }


/* ------------------------------------------------------------------ */

update_members()
   {
   int status;
   int interval;
   char tmps[TMPSTRLEN];
   int i;
   int keep;
   
   
   /* check that we still have a results window */
   status = Et_EvalInt(__FILE__,__LINE__,"s","winfo exists .members");
   if (! status)
      {
      Tcl_DeleteTimerHandler(member_timer_token);
      return(0);
      }
      
   /* get rid of the old data */
   Et_Eval(__FILE__,__LINE__,"s",".members.top.list delete 1.0 end");
   
   time(&now);
   
   keep = Et_EvalInt(__FILE__,__LINE__,"s","set keep");
   Et_Eval(__FILE__,__LINE__,"s",".members.top.list tag configure gray -foreground gray50");
   
   for(i = 1; i <= nummembers; i++)
      {
      /* don't show stale members */
      tdiff = now - memberlist[i].time;
      
      /* should never be more than 2 * MIN, but add some slack
         for missed packets */
         
      if (tdiff > MIN_INTERVAL_MEMBER * 4)
         {
         if (keep)
            {
            /* set text color grey */
            sprintf(tmps, "%s@%s\n", memberlist[i].user, memberlist[i].host);
            Et_Eval(__FILE__,__LINE__,"sss",".members.top.list insert end \"",(tmps),"\" gray");
            continue;
            }
         else
            {
            continue;
            }
         }
      sprintf(tmps, "%s@%s\n", memberlist[i].user, memberlist[i].host);
      Et_Eval(__FILE__,__LINE__,"sss",".members.top.list insert end \"",(tmps),"\"");
      }
   
   /* and update the Tk display */
   Et_Eval(__FILE__,__LINE__,"s","update idletasks");
   
   /* handler uses msecs so ... */
   interval = UPDATE_TIME * 1000; 
   
   /* infinite loop to this same function */
   member_timer_token =  Tcl_CreateTimerHandler(interval, 
     (Tk_TimerProc*)update_members, (ClientData)NULL);
   }

   

/******* Automatically generated code follows ********/
#ifdef __cplusplus
#  define EXTERN extern "C"
#else
#  define EXTERN extern
#endif
EXTERN void Et_InstallCommand(char *,int (*)(void*,struct Tcl_Interp*,int,char**));
void Et_Init_results_c(void){
  Et_InstallCommand("viewmembers",Et_Proc_viewmembers);
}
